require "defines"

--flying text colors
RED = {r = 0.7}
GREEN = {g = 0.7}
YELLOW = {r = 0.7, g = 0.7}


game.oninit(function()
    main = game.player.getinventory(defines.inventory.playermain)
		glob.active = true
		glob.ammostacksize = 25
    glob.coalstacksize = 64
    local test=false
    if test == true then
      game.player.print("initialized")
      game.player.insert{name="car", count=3}
      game.player.insert{name="coal", count=120}
      game.player.insert{name="basic-bullet-magazine", count=200}
      game.player.insert{name="piercing-bullet-magazine", count=10}
      game.player.insert{name="gun-turret", count=10}
    end
end)

game.onload(function() --I'm assuming this is for instances when people have already started a world?
	if glob.active == nil then
		glob.active = true
		glob.ammostacksize = 25
    glob.coalstacksize = 64
	end
end)

game.onevent(defines.events.onbuiltentity, function(event)
--[ option 1
  if glob.active then
    autoLoadCoded(event.createdentity)
  end
-- end of option 1]]

--[[ option 2
	if glob.active then
		if event.createdentity.name == "car" then
			autoLoadGiven(event.createdentity, glob.coalstacksize, "coal")
		elseif event.createdentity.name == "gun-turret" then
			autoLoadGiven(event.createdentity, glob.ammostacksize, whatAmmo())
		end
	end
-- end of option 2]]
end)

--
--Functions
--

--[[Yours
function autoLoadCar(car)
	local main = game.player.getinventory(defines.inventory.playermain)
	local coalcount = main.getitemcount("coal")
	local coalstack = game.itemprototypes["coal"].stacksize
	if coalcount > 0 then
		if coalcount > coalstack then
			main.remove({name="coal", count=coalstack})
			car.insert({name="coal", count=coalstack})
			text("+"..coalstack.." "..game.getlocaliseditemname("coal"), car.position, GREEN)
		else
			main.remove({name="coal", count=coalcount})
			car.insert({name="coal", count=coalcount})
			text("+"..coalcount.." "..game.getlocaliseditemname("coal"), car.position, YELLOW)
		end
	else
		text("No fuel.", car.position, RED)
	end
end

function autoLoadTurret(turret)
	local main = game.player.getinventory(defines.inventory.playermain)
	local pbm = main.getitemcount("piercing-bullet-magazine")
	local bbm = main.getitemcount("basic-bullet-magazine")
	if pbm > 0 then
		if pbm > glob.ammostacksize then
			main.remove({name="piercing-bullet-magazine", count=glob.ammostacksize})
			turret.insert({name="piercing-bullet-magazine", count=glob.ammostacksize})
			text("+"..glob.ammostacksize.." "..game.getlocaliseditemname("piercing-bullet-magazine"), turret.position, GREEN)
		else
			main.remove({name="piercing-bullet-magazine", count=pbm})
			turret.insert({name="piercing-bullet-magazine", count=pbm})
			text("+"..pbm.." "..game.getlocaliseditemname("piercing-bullet-magazine"), turret.position, YELLOW)
		end
	elseif bbm > 0 then
		if bbm > glob.ammostacksize then
			main.remove({name="basic-bullet-magazine", count=glob.ammostacksize})
			turret.insert({name="basic-bullet-magazine", count=glob.ammostacksize})
			text("+"..glob.ammostacksize.." "..game.getlocaliseditemname("basic-bullet-magazine"), turret.position, GREEN)
		else
			main.remove({name="basic-bullet-magazine", count=bbm})
			turret.insert({name="basic-bullet-magazine", count=bbm})
			text("+"..bbm.." "..game.getlocaliseditemname("basic-bullet-magazine"), turret.position, YELLOW)
		end
	else
		text("No ammo.", turret.position, RED)
	end
end
--]]

function text(line, pos, colour) --colour as optional
  if colour == nil then
    game.createentity({name="flying-text", position=pos, text=line})
  else
    game.createentity({name="flying-text", position=pos, text=line, color=colour})
  end
end

--
-- Mod interface
--

remote.addinterface("autofill",
{
  setammostacksize = function(amount)
		if amount > 0 and amount <= 100 then
			glob.ammostacksize = amount
		end
  end,
	setactive = function(turnOn)
		if turnOn then
			glob.active = true
		else
			glob.active = false
		end
  end,
})

--
-- Flexible Functions
--

function autoLoadCoded(entity) --option 1
  local item
  local itemcount = 0 -- simply easier if this is not nil
  if (entity.name == "car") or (entity.name == "gun-turret") then
    if entity.name == "car" then
      item = "coal"
      itemcount = main.getitemcount(item)
      if glob.coalstacksize < itemcount then itemcount=glob.coalstacksize end
    elseif entity.name == "gun-turret" then 
      local result = whatAmmo()
      item = result[1]
      itemcount = result[2]
      if glob.ammostacksize < itemcount then itemcount=glob.ammostacksize end
    end
    
    if itemcount > 0 then
        main.remove({name=item, count=itemcount})
        entity.insert({name=item, count=itemcount})
      if (itemcount == glob.coalstacksize) or (itemcount == glob.ammostacksize) then
        text("+"..itemcount.." "..game.getlocaliseditemname(item), entity.position, GREEN)
      else
        text("+"..itemcount.." "..game.getlocaliseditemname(item), entity.position, YELLOW)
      end
    else
      text("No: "..game.getlocaliseditemname(item), entity.position, RED)
    end
  end
end

--[Option 2
function autoLoadGiven(entity, stack, item)
  if (item == nil) then
    local result = whatAmmo()
    item = result[1]
    itemcount = result[2]
  end
	local main = game.player.getinventory(defines.inventory.playermain)
  local item
  local itemcount = main.getitemcount(item) -- get amt in inv
  
  if itemcount > stack then --check if we have enough to give the full stacksize
    itemcount = stack
    color = GEEN
  elseif itemcount == 0 then
    color = false
  else
    color = YELLOW
  end
  
  if color then
    main.remove({name=item, count=itemcount})
    entity.insert({name=item, count=itemcount})
    text("+"..itemcount.." "..game.getlocaliseditemname(item), entity.position, color)
  else
    text("No: "..game.getlocaliseditemname(item), entity.position, RED)
  end
end

function whatAmmo()
  local curitem = "piercing-bullet-magazine"
  local itemcount = main.getitemcount(curitem)
    --apparently you can not get ammo_type from itemprototypes right now or this would work well (though, probably better to get a table of bullets at init rather than redo it everytime)
    --[[for _, item in pairs(game.itemprototypes) do
      if item.type == "ammo" and item["ammo_type"] and item["ammo_type"].category == "bullet" then
        if curitem == nil then curitem = item end
        local count = main.getitemcount(item)
        if count > itemcount then
          curitem = item
          itemcount = count
        end
      end
    end--]]
    
    --work around
    if itemcount == 0 then
      curitem = "basic-bullet-magazine"
      itemcount = main.getitemcount(curitem)
    end
    return {curitem, itemcount}
  end
--]] end of option 2